/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Fasterfox.
 *
 * The Initial Developer of the Original Code is
 * Tony Gentilcore.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  See readme.txt
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var FasterFoxInit = function() {
    //Utils
    var getVersion = function() {
        var extensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);  
        var addon = extensionManager.getItemForID("{c36177c0-224a-11da-8cd6-0800200c9a91}");  
        return addon.version; 
    };
    
    this.pub = {};
    var FF_PREFS = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("extensions.fasterfox.");
    var CURRENT_VERSION =  getVersion();
    
    pub.init = function() {
        try {
            if (!gBrowser)
                return;
        } catch (e) { return; }
        var version = 0;
        var currentVersion = 0;
	var branch = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("extensions.fasterfox.");
	var children = branch.getChildList("", {});
        var prefType = FF_PREFS.getPrefType('version');
	    if (prefType != FF_PREFS.PREF_INVALID)
		version =  FF_PREFS.getCharPref('version');
        FF_PREFS.setCharPref('version',CURRENT_VERSION);
	AddItInstaller.debug("ver: "+version);
	AddItInstaller.debug("chidren: "+children.length);
	if (version == 0 || children.length == 0) {
            //install
            window.setTimeout(function () {window.openDialog('chrome://fasterfox/content/install.xul', 'FasterFox Install', 'centerscreen,chrome,scrollbars=yes,resizable=yes', '0');}, 1000);
        } else if (children.length != 0 && version !=  CURRENT_VERSION) {
	     //update
            window.setTimeout(function () {window.openDialog('chrome://fasterfox/content/update.xul', 'FasterFox Update', 'centerscreen,chrome,scrollbars=yes,resizable=yes', '0');}, 1000);
	} 
    };
    return pub;
}();
