/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Fasterfox.
 *
 * The Initial Developer of the Original Code is
 * Tony Gentilcore.
 * Portions created by the Initial Developer are Copyright (C) 2005
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  See readme.txt
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var FasterFoxHelp = function() {   
    this.pub = {};
    
    var FF_PREFS = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("extensions.fasterfox.");
    var AI_PREFS = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("extensions.addit.");
    var AI_BUNDLE = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService)
                               .createBundle("chrome://fasterfox/locale/addit.properties");
                               
    pub.init = function() {
        var box = document.getElementById("helpBox");
        var vbox = document.createElement("vbox");
        var item;
        if (box) {
            var enumerator = document.getElementById('fasterfox-help-stringbundle').strings;
            var bundle = document.getElementById('fasterfox-help-stringbundle');
            var stringIndex = 1;
            while (enumerator.hasMoreElements()) {
                enumerator.getNext(); 
                item = document.createElement("textbox");
                item.setAttribute("multiline",true);
                item.setAttribute("class","plain");
                item.setAttribute("style","width:450px;background-color: transparent;");
                item.setAttribute("value",bundle.getString("helpItem" + stringIndex));
                vbox.appendChild(item);
                stringIndex++;
            }
        }
        if (vbox.childNodes.length > 0) {
            box.appendChild(vbox);
            document.getElementById("helpGroupBox").setAttribute("collapsed","false");
        }
        vbox = null;
        box = null;
        item = null;
        enumerator = null;
    };
    pub.restart = function() {
        var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                .getService(Components.interfaces.nsIPromptService);
        var isInstallsComplete = false;
        var prefType = AI_PREFS.getPrefType('installsComplete');
	    if (prefType != AI_PREFS.PREF_INVALID)
		isInstallsComplete =  AI_PREFS.getBoolPref('installsComplete');
        if (isInstallsComplete && promptService.confirm(null,AI_BUNDLE.GetStringFromName("installRestartConfirmTitle"), AddItInstaller.BUNDLE.GetStringFromName("installRestartConfirm"))) { 
            AddItInstaller.restart();
        }
    }
    return pub;
}();