/*
 * Version: Open Software License v. 2.1
 *
 * The contents of this file are subject to the Open Software License Version
 * 2.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.opensource.org/licenses/osl-2.1.php
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the addonfox.
 *
 * The Initial Developer of the Original Code is
 * Linkular LLC
 *
 * Portions created by the Initial Developer are Copyright (C) 2008
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * */
var EXPORTED_SYMBOLS = ["mCurrentElementIndex","mNumberOfElements"];

//static
var mCurrentElementIndex = {
    value : 0
    };
    
var mNumberOfElements = {
    value : 2
    };
    
var FasterFoxInstall = function() {
    var pub = {};
    const RESOURCE_INSTALL = "resource://additinstaller/install.js";
    const ELEMENT_ID_PREFIX = "FasterFox_Install_";
    const NEXT = "next";
    const BACK = "back";
    const FINISH = "finish";
    const FINISH_AND_INSTALL = "finishAndInstall";
    
    pub.BUNDLE = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService)
                               .createBundle("chrome://fasterfox/locale/addit.properties");
    
    //show first page, config next and hide back
    pub.init = function() {
        mCurrentElementIndex.value = 0;
	Components.utils.import(RESOURCE_INSTALL);
	for (var elementIndex = 1 ; elementIndex < mNumberOfElements.value ; elementIndex++) {
	    document.getElementById(ELEMENT_ID_PREFIX + elementIndex).collapsed = true;
	}
	document.getElementById(ELEMENT_ID_PREFIX + mCurrentElementIndex.value).collapsed = false;
	
	//document.getElementById(ELEMENT_ID_PREFIX + NEXT).addEventListener("click",FasterFoxInstall.next,false);
	//document.getElementById(ELEMENT_ID_PREFIX + BACK).addEventListener("click",FasterFoxInstall.back,false);
	if (mCurrentElementIndex.value + 1 == mNumberOfElements.value) {
	    document.getElementById(ELEMENT_ID_PREFIX + NEXT).collapsed = true;
	    document.getElementById(ELEMENT_ID_PREFIX + NEXT).disabled = true;
	    document.getElementById(ELEMENT_ID_PREFIX + FINISH).collapsed = false;
	     document.getElementById(ELEMENT_ID_PREFIX + FINISH).disabled = false;
            document.getElementById(ELEMENT_ID_PREFIX + FINISH_AND_INSTALL).collapsed = false;
	    document.getElementById(ELEMENT_ID_PREFIX + FINISH_AND_INSTALL).disabled = false;
	    document.getElementById(ELEMENT_ID_PREFIX + FINISH).focus();
        } else {
	    document.getElementById(ELEMENT_ID_PREFIX + NEXT).collapsed = false;
	    document.getElementById(ELEMENT_ID_PREFIX + NEXT).disabled = false;
	    document.getElementById(ELEMENT_ID_PREFIX + FINISH).collapsed = true;
	     document.getElementById(ELEMENT_ID_PREFIX + FINISH).disabled = true;
            document.getElementById(ELEMENT_ID_PREFIX + FINISH_AND_INSTALL).collapsed = true;
	    document.getElementById(ELEMENT_ID_PREFIX + FINISH_AND_INSTALL).disabled = true;
	    document.getElementById(ELEMENT_ID_PREFIX + NEXT).focus();
        }
	document.getElementById(ELEMENT_ID_PREFIX + NEXT).disabled = false;
	document.getElementById(ELEMENT_ID_PREFIX + BACK).disabled = true;
    };
    
    //hide current screen, show next, config next and back
    pub.next = function(){
	Components.utils.import(RESOURCE_INSTALL);
	if (mCurrentElementIndex.value + 1 == mNumberOfElements.value) {
	    return true;
	}
        if (mCurrentElementIndex.value + 1 == mNumberOfElements.value - 1) {
	    document.getElementById(ELEMENT_ID_PREFIX + NEXT).collapsed = true;
	    document.getElementById(ELEMENT_ID_PREFIX + NEXT).disabled = true;
	    document.getElementById(ELEMENT_ID_PREFIX + FINISH).collapsed = false;
	     document.getElementById(ELEMENT_ID_PREFIX + FINISH).disabled = false;
            document.getElementById(ELEMENT_ID_PREFIX + FINISH_AND_INSTALL).collapsed = false;
	    document.getElementById(ELEMENT_ID_PREFIX + FINISH_AND_INSTALL).disabled = false;
            document.getElementById(ELEMENT_ID_PREFIX + FINISH).focus();
	} 
	document.getElementById(ELEMENT_ID_PREFIX + mCurrentElementIndex.value).collapsed = true;
	document.getElementById(ELEMENT_ID_PREFIX + ++mCurrentElementIndex.value).collapsed = false;
        document.getElementById(ELEMENT_ID_PREFIX + BACK).collapsed = false;
	document.getElementById(ELEMENT_ID_PREFIX + BACK).disabled = false;
        return true;
    };
    
    //hide current screen, show previous, config next and back
    pub.back = function(){
	Components.utils.import(RESOURCE_INSTALL);
	if (mCurrentElementIndex.value == 0) {
	    //This should not occur, because back should be disabled
	    document.getElementById(ELEMENT_ID_PREFIX + BACK).disabled = true;
	    return;
	}
	if (mCurrentElementIndex.value == 1) {
	    document.getElementById(ELEMENT_ID_PREFIX + BACK).disabled = true;
	}
        if (mCurrentElementIndex.value + 1 == mNumberOfElements.value) {
	    document.getElementById(ELEMENT_ID_PREFIX + NEXT).collapsed = false;
	    document.getElementById(ELEMENT_ID_PREFIX + NEXT).disabled = false;
	    document.getElementById(ELEMENT_ID_PREFIX + FINISH).collapsed = true;
	     document.getElementById(ELEMENT_ID_PREFIX + FINISH).disabled = true;
            document.getElementById(ELEMENT_ID_PREFIX + FINISH_AND_INSTALL).collapsed = true;
	    document.getElementById(ELEMENT_ID_PREFIX + FINISH_AND_INSTALL).disabled = true;
        }
	document.getElementById(ELEMENT_ID_PREFIX + mCurrentElementIndex.value).collapsed = true;
	document.getElementById(ELEMENT_ID_PREFIX + --mCurrentElementIndex.value).collapsed = false;
        return;
    };
        
    return pub;
}();